<template>
  <v-container fluid>
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-text-field
        v-model="login.mail"
        :rules="emailRules"
        label="Correo Electrónico"
        required
      ></v-text-field>

      <v-text-field
        label="Contraseña"
        v-model="login.password"
        required
        :rules="passwordRules"
        :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
        :type="show ? 'text' : 'password'"
        @click:append="show = !show"
        @keypress.enter="loginPost"
      ></v-text-field>

      <v-divider class="mb-5 mt-2"></v-divider>

      <v-btn
        block
        class="mr-4"
        color="pink accent-2"
        :disabled="loading"
        :loading="loading"
        @click="loginPost"
      >
        Iniciar Sesión
      </v-btn>

      <div align="center" class="mt-5">
        ¿Eres nuevo?
        <v-btn text dark x-small @click="toRegister"> clic aquí</v-btn>
      </div>
    </v-form>
    <v-snackbar v-model="snackbar" top :multi-line="multiLine">
      {{ text }}
      <template v-slot:action="{ attrs }">
        <v-btn color="pink" text v-bind="attrs" @click="snackbar = false">
          Cerrar
        </v-btn>
      </template>
    </v-snackbar>
  </v-container>
</template>

<script lang="ts">
import { VForm } from 'types'
import { Vue, Component, Ref } from 'nuxt-property-decorator'

@Component({
  name: 'login-form',
})
export default class LoginForm extends Vue {
  @Ref('form') readonly form!: VForm

  valid: boolean = true
  login = {
    mail: '',
    password: '',
  }
  emailRules: Array<any> = [
    (v: any) => !!v || 'Digite su correo electrónico',
    (v: any) => /.+@.+\..+/.test(v) || 'El correo electrónico no es válido',
  ]
  show = false
  passwordRules: Array<any> = [(v: any) => !!v || 'Digite su contraseña']

  loading = false

  snackbar = false
  text = ''
  multiLine = true

  loginPost() {
    this.loading = true
    if (this.form.validate()) {
      this.$auth
        .loginWith('local', { data: this.login })
        .then((resp: any) => {
          this.loading = false
          this.$auth.$storage.setUniversal('userId', resp.data.userId)
          this.$auth.$storage.setUniversal('menu', resp.data.menu)
          // this.$router.push('/inicio')
          window.location.href = '/inicio'
        })
        .catch((err) => {
          if (err.response.status === 404 && err.response.data.code === 404) {
            this.snackbar = true
            this.text = 'El correo electrónico o la contraseña no coinciden.'
          }
          this.loading = false
        })
    } else {
      this.loading = false
    }
  }

  toRegister() {
    this.$router.push('/registro')
  }
}
</script>